'2008 IDesign Inc. 
'Questions? Comments? go to 
'http://www.idesign.net


Imports Microsoft.VisualBasic
Imports System
Imports System.ServiceModel
Imports System.Windows.Forms
Imports ServiceModelEx
Imports ServiceModelEx.Transactional


<ServiceContract> _
Friend Interface IMyCounter
   <OperationContract, TransactionFlow(TransactionFlowOption.Allowed)> _
   Sub Increment(ByVal instanceId As String)

   <OperationContract, TransactionFlow(TransactionFlowOption.Allowed)> _
   Sub RemoveCounter(ByVal instanceId As String)
End Interface


<ServiceBehavior(InstanceContextMode:=InstanceContextMode.PerCall)> _
Friend Class MyService
	Implements IMyCounter
   Private Shared m_StateStore As TransactionalDictionary(Of String,Integer) = New TransactionalDictionary(Of String,Integer)()

   Public Sub New()
	  MessageBox.Show("MyService()","MyService")
   End Sub
   <OperationBehavior(TransactionScopeRequired:=True)> _
   Public Sub Increment(ByVal instanceId As String) Implements IMyCounter.Increment
	  If m_StateStore.ContainsKey(instanceId) = False Then
		 m_StateStore(instanceId) = 0
	  End If
	  m_StateStore(instanceId) += 1
	  MessageBox.Show("Counter = " & m_StateStore(instanceId),"MyService.Increment()")
   End Sub
   <OperationBehavior(TransactionScopeRequired:=True)> _
   Public Sub RemoveCounter(ByVal instanceId As String) Implements IMyCounter.RemoveCounter
	  If m_StateStore.ContainsKey(instanceId) Then
		 MessageBox.Show("RemoveCounter()","MyService")
		 m_StateStore.Remove(instanceId)
	  End If
   End Sub
End Class