'2008 IDesign Inc. 
'Questions? Comments? go to 
'http://www.idesign.net


Imports Microsoft.VisualBasic
Imports System
Imports System.Threading
Imports System.ServiceModel.Persistence

Namespace ServiceModelEx
   Public MustInherit Class MemoryProvider
	   Inherits PersistenceProvider
	  Private m_InstanceStore As IInstanceStore(Of Guid,Object)

	  Public Sub New(ByVal id As Guid, ByVal instanceStore As IInstanceStore(Of Guid,Object))
		  MyBase.New(id)
		 m_InstanceStore = instanceStore
	  End Sub

	  Public Overrides Function Create(ByVal instance As Object, ByVal timeout As TimeSpan) As Object
		 m_InstanceStore(Id) = instance
		 Return Nothing
	  End Function
	  Public Overrides Function Load(ByVal timeout As TimeSpan) As Object
		 If m_InstanceStore.ContainsInstance(Id) Then
			Return m_InstanceStore(Id)
		 End If
		 Return Nothing
	  End Function
	  Public Overrides Sub Delete(ByVal instance As Object, ByVal timeout As TimeSpan)
		 m_InstanceStore.RemoveInstance(Id)
	  End Sub
	  Protected Overrides Sub OnClose(ByVal timeout As TimeSpan)
		 Throw New NotImplementedException()
	  End Sub
	  Protected Overrides Sub OnOpen(ByVal timeout As TimeSpan)
	  End Sub
	  Public Overrides Function Update(ByVal instance As Object, ByVal timeout As TimeSpan) As Object
		 m_InstanceStore(Id) = instance
		 Return Nothing
	  End Function

	  Protected Overrides ReadOnly Property DefaultCloseTimeout() As TimeSpan
		 Get
			Return TimeSpan.MaxValue
		 End Get
	  End Property

	  Protected Overrides ReadOnly Property DefaultOpenTimeout() As TimeSpan
		 Get
			Return TimeSpan.MaxValue
		 End Get
	  End Property
	  Public Overrides Function BeginCreate(ByVal instance As Object, ByVal timeout As TimeSpan, ByVal callback As AsyncCallback, ByVal state As Object) As IAsyncResult
		 Throw New NotImplementedException()
	  End Function

	  Public Overrides Function BeginDelete(ByVal instance As Object, ByVal timeout As TimeSpan, ByVal callback As AsyncCallback, ByVal state As Object) As IAsyncResult
		 Throw New NotImplementedException()
	  End Function

	  Public Overrides Function BeginLoad(ByVal timeout As TimeSpan, ByVal callback As AsyncCallback, ByVal state As Object) As IAsyncResult
		 Throw New NotImplementedException()
	  End Function

	  Public Overrides Function BeginUpdate(ByVal instance As Object, ByVal timeout As TimeSpan, ByVal callback As AsyncCallback, ByVal state As Object) As IAsyncResult
		 Throw New NotImplementedException()
	  End Function

	  Public Overrides Function EndCreate(ByVal result As IAsyncResult) As Object
		 Throw New NotImplementedException()
	  End Function

	  Public Overrides Sub EndDelete(ByVal result As IAsyncResult)
		 Throw New NotImplementedException()
	  End Sub

	  Public Overrides Function EndLoad(ByVal result As IAsyncResult) As Object
		 Throw New NotImplementedException()
	  End Function

	  Public Overrides Function EndUpdate(ByVal result As IAsyncResult) As Object
		 Throw New NotImplementedException()
	  End Function

	  Protected Overrides Sub OnAbort()
	  End Sub

	  Protected Overrides Function OnBeginClose(ByVal timeout As TimeSpan, ByVal callback As AsyncCallback, ByVal state As Object) As IAsyncResult
		 Throw New NotImplementedException()
	  End Function

	  Protected Overrides Function OnBeginOpen(ByVal timeout As TimeSpan, ByVal callback As AsyncCallback, ByVal state As Object) As IAsyncResult
		 Throw New NotImplementedException()
	  End Function

	  Protected Overrides Sub OnEndClose(ByVal result As IAsyncResult)
		 Throw New NotImplementedException()
	  End Sub

	  Protected Overrides Sub OnEndOpen(ByVal result As IAsyncResult)
		 Throw New NotImplementedException()
	  End Sub
   End Class
End Namespace
