'2008 IDesign Inc. 
'Questions? Comments? go to 
'http://www.idesign.net


Imports Microsoft.VisualBasic
Imports System
Imports System.ServiceModel
Imports System.ServiceModel.Channels
Imports System.ServiceModel.Configuration
Imports System.Configuration
Imports System.Diagnostics
Imports System.Net.Security

Namespace ServiceModelEx
   Public Class NetNamedPipeContextBinding
	   Inherits NetNamedPipeBinding
	  Friend Const SectionName As String = "netNamedPipeContextBinding"

	  Private privateContextProtectionLevel As ProtectionLevel
	  Public Property ContextProtectionLevel() As ProtectionLevel
		  Get
			  Return privateContextProtectionLevel
		  End Get
		  Set(ByVal value As ProtectionLevel)
			  privateContextProtectionLevel = value
		  End Set
	  End Property

	  Public Sub New()
		 ContextProtectionLevel = ProtectionLevel.EncryptAndSign
	  End Sub
	  Public Sub New(ByVal securityMode As NetNamedPipeSecurityMode)
		  MyBase.New(securityMode)
		 ContextProtectionLevel = ProtectionLevel.EncryptAndSign
	  End Sub
	  Public Sub New(ByVal configurationName As String)
		 ContextProtectionLevel = ProtectionLevel.EncryptAndSign
		 ApplyConfiguration(configurationName)
	  End Sub
	  'The heart of the custom binding 
	  Public Overrides Function CreateBindingElements() As BindingElementCollection
		 Dim element As BindingElement = New ContextBindingElement(ContextProtectionLevel,ContextExchangeMechanism.ContextSoapHeader)

		 Dim elements As BindingElementCollection = MyBase.CreateBindingElements()
		 elements.Insert(0,element)

		 Return elements
	  End Function
	  Private Sub ApplyConfiguration(ByVal configurationName As String)
		 Dim config As Configuration = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None)
		 Dim sectionGroup As ServiceModelSectionGroup = ServiceModelSectionGroup.GetSectionGroup(config)

		 Dim bindings As BindingsSection = sectionGroup.Bindings

		 Dim section As NetNamedPipeContextBindingCollectionElement = CType(bindings(SectionName), NetNamedPipeContextBindingCollectionElement)
		 Dim element As NetNamedPipeContextBindingElement = section.Bindings(configurationName)
		 If element Is Nothing Then
			Throw New ConfigurationErrorsException("There is no binding named " & configurationName & " at " & section.BindingName)
		 Else
			element.ApplyConfiguration(Me)
		 End If
	  End Sub
   End Class
   Public Class NetNamedPipeContextBindingElement
	   Inherits NetNamedPipeBindingElement
	  Private Const ContextProtectionLevelName As String = "contextProtectionLevel"


	  Public Sub New()
		 Initialize()
	  End Sub
	  Public Sub New(ByVal name As String)
		  MyBase.New(name)
		 Initialize()
	  End Sub

	  Private Sub Initialize()
		 Dim [property] As New ConfigurationProperty(ContextProtectionLevelName,GetType(ProtectionLevel),ProtectionLevel.EncryptAndSign)
		 Properties.Add([property])

		 ContextProtectionLevel = ProtectionLevel.EncryptAndSign
	  End Sub
	  Protected Overrides Sub OnApplyConfiguration(ByVal binding As Binding)
		 MyBase.OnApplyConfiguration(binding)
		 Dim netNamedPipeContextBinding As NetNamedPipeContextBinding = TryCast(binding, NetNamedPipeContextBinding)
		 Debug.Assert(netNamedPipeContextBinding IsNot Nothing)

		 netNamedPipeContextBinding.ContextProtectionLevel = ContextProtectionLevel
	  End Sub
	  Protected Overrides ReadOnly Property BindingElementType() As Type
		 Get
			Return GetType(NetNamedPipeContextBinding)
		 End Get
	  End Property

	  Public Property ContextProtectionLevel() As ProtectionLevel
		 Get
			Return CType(MyBase.Item(ContextProtectionLevelName), ProtectionLevel)
		 End Get
		 Set(ByVal value As ProtectionLevel)
			MyBase.Item(ContextProtectionLevelName) = value
		 End Set
	  End Property
   End Class
   Public Class NetNamedPipeContextBindingCollectionElement
	   Inherits StandardBindingCollectionElement(Of NetNamedPipeContextBinding,NetNamedPipeContextBindingElement)
   End Class
End Namespace
