'2008 IDesign Inc. 
'Questions? Comments? go to 
'http://www.idesign.net



Imports Microsoft.VisualBasic
Imports System
Imports System.IO
Imports System.Runtime.Serialization
Imports System.Collections.Generic
Imports System.Diagnostics
Imports System.Runtime.Serialization.Formatters.Binary
Imports ServiceModelEx.Transactional

Namespace ServiceModelEx
   Public Class TransactionalInstanceStore(Of ID As IEquatable(Of ID), T As Class)
	   Implements IInstanceStore(Of ID,T)
	  Private m_Instance As Transactional(Of T) = New Transactional(Of T)()

	  Shared Sub New()
		 'Verify [Serializable] on T
		 Debug.Assert(GetType(T).IsSerializable)
	  End Sub

        Public Sub RemoveInstance(ByVal instanceId As ID) Implements IInstanceStore(Of ID, T).RemoveInstance
            Me(instanceId) = Nothing
        End Sub
        Public Function ContainsInstance(ByVal instanceId As ID) As Boolean Implements IInstanceStore(Of ID, T).ContainsInstance
            Return Me(instanceId) IsNot Nothing

        End Function
        Default Public Property Item(ByVal instanceId As ID) As T Implements IInstanceStore(Of ID, T).Item
            Get
                SyncLock m_Instance
                    Return m_Instance.Value
                End SyncLock
            End Get
            Set(ByVal value As T)
                SyncLock m_Instance
                    m_Instance.Value = value
                End SyncLock
            End Set
        End Property
   End Class
End Namespace