'2008 IDesign Inc. 
'Questions? Comments? go to 
'http://www.idesign.net



Imports Microsoft.VisualBasic
Imports System
Imports System.IO
Imports System.Runtime.Serialization
Imports System.Collections.Generic
Imports System.Diagnostics
Imports System.Runtime.Serialization.Formatters.Binary
Imports ServiceModelEx.Transactional

Namespace ServiceModelEx
   Public Class TransactionalMemoryStore(Of ID As IEquatable(Of ID), T)
	   Implements IInstanceStore(Of ID,T)
	  Private Shared m_Instances As TransactionalDictionary(Of ID,T) = New TransactionalDictionary(Of ID,T)()

	  Shared Sub New()
		 'Verify [Serializable] on T
		 Debug.Assert(GetType(T).IsSerializable)

		 'Verify [Serializable] on ID
		 Debug.Assert(GetType(ID).IsSerializable)
	  End Sub

	  Public Sub New()
	  End Sub

        Public Sub RemoveInstance(ByVal instanceId As ID) Implements IInstanceStore(Of ID, T).RemoveInstance
            SyncLock m_Instances
                Debug.Assert(ContainsInstance(instanceId))
                m_Instances.Remove(instanceId)
            End SyncLock
        End Sub
        Public Function ContainsInstance(ByVal instanceId As ID) As Boolean Implements IInstanceStore(Of ID, T).ContainsInstance
            SyncLock m_Instances
                Return m_Instances.ContainsKey(instanceId)
            End SyncLock
        End Function
        Default Public Property Item(ByVal instanceId As ID) As T Implements IInstanceStore(Of ID, T).Item
            Get
                SyncLock m_Instances
                    Return m_Instances(instanceId)
                End SyncLock
            End Get
            Set(ByVal value As T)
                SyncLock m_Instances
                    m_Instances(instanceId) = value
                End SyncLock
            End Set
        End Property
   End Class
End Namespace