'2008 IDesign Inc. 
'Questions? Comments? go to 
'http://www.idesign.net


Imports Microsoft.VisualBasic
Imports System
Imports System.ServiceModel
Imports System.Collections.Generic
Imports System.Diagnostics
Imports System.ServiceModel.Channels
Imports System.ServiceModel.Description
Imports System.Runtime.CompilerServices

Namespace ServiceModelEx
   Public NotInheritable Class InProcFactory
	  Private Structure HostRecord
		 Public Sub New(ByVal host As ServiceHost, ByVal address As String)
			Me.Host = host
			Me.Address = New EndpointAddress(address)
		 End Sub
		 Public ReadOnly Host As ServiceHost
		 Public ReadOnly Address As EndpointAddress
	  End Structure
	  Private Shared ReadOnly BaseAddress As New Uri("net.pipe://localhost/" & Guid.NewGuid().ToString())
	  Private Shared ReadOnly Binding As Binding
	  Private Shared m_Hosts As Dictionary(Of Type,HostRecord) = New Dictionary(Of Type,HostRecord)()

	  Private Sub New()
	  End Sub
	  Shared Sub New()
		 Dim binding As NetNamedPipeBinding = New NetNamedPipeContextBinding()
		 binding.TransactionFlow = True
		 InProcFactory.Binding = binding
		 AddHandler AppDomain.CurrentDomain.ProcessExit, AddressOf AnonymousMethod1
	  End Sub
	  Private Shared Sub AnonymousMethod1(ByVal sender As Object, ByVal e As System.EventArgs)
												For Each hostRecord As HostRecord In m_Hosts.Values
												   hostRecord.Host.Close()
												Next hostRecord
	  End Sub
	  Public Shared Function CreateInstance(Of S As I, I As Class)() As I
		 Dim hostRecord As HostRecord = GetHostRecord(Of S,I)()
		 Return ChannelFactory(Of I).CreateChannel(Binding,hostRecord.Address)
	  End Function
	  Private Shared Function GetHostRecord(Of S As I, I As Class)() As HostRecord
		 Dim hostRecord As HostRecord
		 If m_Hosts.ContainsKey(GetType(S)) Then
			hostRecord = m_Hosts(GetType(S))
		 Else
			Dim host As New ServiceHost(GetType(S),BaseAddress)
			Dim address As String = BaseAddress.ToString() & Guid.NewGuid().ToString()
			hostRecord = New HostRecord(host,address)
			m_Hosts.Add(GetType(S),hostRecord)
			host.AddServiceEndpoint(GetType(I),Binding,address)
			host.Open()
		 End If
		 Return hostRecord
	  End Function
	  Public Shared Sub CloseProxy(Of I As Class)(ByVal instance As I)
		 Dim proxy As ICommunicationObject = TryCast(instance, ICommunicationObject)
		 Debug.Assert(proxy IsNot Nothing)
		 proxy.Close()
	  End Sub
   End Class
End Namespace