'2008 IDesign Inc. 
'Questions? Comments? go to 
'http://www.idesign.net


Imports Microsoft.VisualBasic
Imports System
Imports System.ServiceModel
Imports System.ServiceModel.Channels
Imports System.ServiceModel.Description
Imports System.Collections.ObjectModel
Imports System.ServiceModel.Persistence

Namespace ServiceModelEx
   <AttributeUsage(AttributeTargets.Class)> _
   Public Class TransactionalBehaviorAttribute
	   Inherits Attribute
	   Implements IServiceBehavior
	  Private privateTransactionRequiredAllOperations As Boolean
	  Public Property TransactionRequiredAllOperations() As Boolean
		  Get
			  Return privateTransactionRequiredAllOperations
		  End Get
		  Set(ByVal value As Boolean)
			  privateTransactionRequiredAllOperations = value
		  End Set
	  End Property

	  Private privateAutoCompleteInstance As Boolean
	  Public Property AutoCompleteInstance() As Boolean
		  Get
			  Return privateAutoCompleteInstance
		  End Get
		  Set(ByVal value As Boolean)
			  privateAutoCompleteInstance = value
		  End Set
	  End Property

	  Public Sub New()
		 TransactionRequiredAllOperations = True
		 AutoCompleteInstance = True
	  End Sub
	  Private Sub Validate(ByVal description As ServiceDescription, ByVal host As ServiceHostBase) Implements IServiceBehavior.Validate
		 Dim durable As New DurableServiceAttribute()
		 durable.SaveStateInOperationTransaction = True
		 description.Behaviors.Add(durable)

		 Dim factory As PersistenceProviderFactory
		 If AutoCompleteInstance Then
			factory = New TransactionalInstanceProviderFactory()
		 Else
			factory = New TransactionalMemoryProviderFactory()
		 End If
		 Dim persistenceBehavior As New PersistenceProviderBehavior(factory)
		 description.Behaviors.Add(persistenceBehavior)

		 If TransactionRequiredAllOperations Then
			For Each endpoint As ServiceEndpoint In description.Endpoints
			   For Each operation As OperationDescription In endpoint.Contract.Operations
				  operation.Behaviors.Find(Of OperationBehaviorAttribute)().TransactionScopeRequired = True
			   Next operation
			Next endpoint
		 End If
	  End Sub
	  Private Sub AddBindingParameters(ByVal description As ServiceDescription, ByVal host As ServiceHostBase, ByVal endpoints As Collection(Of ServiceEndpoint), ByVal parameters As BindingParameterCollection) Implements IServiceBehavior.AddBindingParameters
	  End Sub
	  Private Sub ApplyDispatchBehavior(ByVal description As ServiceDescription, ByVal host As ServiceHostBase) Implements IServiceBehavior.ApplyDispatchBehavior
	  End Sub
   End Class
End Namespace





