'2008 IDesign Inc. 
'Questions? Comments? go to 
'http://www.idesign.net


Imports Microsoft.VisualBasic
Imports System
Imports System.Transactions
Imports System.Diagnostics
Imports System.Runtime.Serialization
Imports System.Runtime.Serialization.Formatters.Binary
Imports System.IO


Namespace ServiceModelEx
    Public NotInheritable Class ResouceManager
        Private Sub New()
        End Sub
        Public Shared Function Clone(Of T)(ByVal source As T) As T
            If Object.ReferenceEquals(source, Nothing) Then
                Return Nothing
            End If
            Debug.Assert(GetType(T).IsSerializable)
            Dim formatter As IFormatter = New BinaryFormatter()
            Dim stream As Stream = New MemoryStream()
            Using stream
                formatter.Serialize(stream, source)
                stream.Seek(0, SeekOrigin.Begin)
                Dim cloneValue As T = CType(formatter.Deserialize(stream), T)
                Return cloneValue
            End Using
        End Function
        Public Shared Sub ConstrainType(ByVal type As Type)
            Dim serializable As Boolean = type.IsSerializable
            If serializable = False Then
                Dim message As String = "The type " & type.ToString & " is not serializable"
                Throw New InvalidOperationException(message)
            End If
        End Sub
        Public Shared Function SameTransaction(ByVal transaction1 As TransactionInformation, ByVal transaction2 As TransactionInformation) As Boolean
            If transaction1.DistributedIdentifier = Guid.Empty AndAlso transaction2.DistributedIdentifier = Guid.Empty Then
                Return transaction1.LocalIdentifier = transaction2.LocalIdentifier
            End If
            Return transaction1.DistributedIdentifier = transaction2.DistributedIdentifier
        End Function
    End Class
End Namespace
