'2008 IDesign Inc. 
'Questions? Comments? go to 
'http://www.idesign.net


Imports Microsoft.VisualBasic
Imports System
Imports System.Threading
Imports System.Collections
Imports System.Collections.Generic
Imports System.Transactions
Imports System.Diagnostics

Imports ServiceModelEx

Namespace ServiceModelEx.Transactional
    Public Class TransactionalArray(Of T)
        Inherits TransactionalCollection(Of T(), T)
        Implements ICloneable, IList
        Public Sub New(ByVal array() As T)
            MyBase.New(array)
        End Sub
        Public Sub New(ByVal collection As IEnumerable(Of T))
            MyBase.New(ToArray(collection))
        End Sub
        Private Shared Function ToArray(ByVal collection As IEnumerable(Of T)) As T()
            Dim length As Integer = 0
            For Each t As T In collection
                length += 1
            Next t
            Dim array(length - 1) As T
            Dim index As Integer = 0
            For Each t As T In collection
                array(index) = t
                index += 1
            Next t
            Return array
        End Function
        Public Sub New(ByVal size As Integer)
            MyBase.New(New T(size - 1) {})
        End Sub

        Default Public Property Item(ByVal index As Integer) As T
            Get
                Return Value(index)
            End Get
            Set(ByVal value As T)
                MyBase.Value(index) = value
            End Set
        End Property
        Public ReadOnly Property Length() As Integer
            Get
                Return Value.Length
            End Get
        End Property
        Public Sub CopyTo(ByRef array As TransactionalArray(Of T), ByVal index As Integer)
            Dim values() As T = Nothing
            Value.CopyTo(values, index)
            array = New TransactionalArray(Of T)(values)
        End Sub

        Public ReadOnly Property IsFixedSize() As Boolean Implements IList.IsFixedSize
            Get
                Return Value.IsFixedSize
            End Get
        End Property
        Public ReadOnly Property IsReadOnly() As Boolean Implements IList.IsReadOnly
            Get
                Return Value.IsReadOnly
            End Get
        End Property
        Public Function Clone() As Object Implements ICloneable.Clone
            Return Value.Clone()
        End Function
        Private Function Add(ByVal value As Object) As Integer Implements IList.Add
            Return (TryCast(value, IList)).Add(value)
        End Function
        Private Sub Clear() Implements IList.Clear
            TryCast(Value, IList).Clear()
        End Sub
        Private Function Contains(ByVal value As Object) As Boolean Implements IList.Contains
            Return (TryCast(value, IList)).Contains(value)
        End Function
        Private Function IndexOf(ByVal value As Object) As Integer Implements IList.IndexOf
            Return (TryCast(value, IList)).IndexOf(value)
        End Function
        Private Sub Insert(ByVal index As Integer, ByVal value As Object) Implements IList.Insert
            TryCast(value, IList).Insert(index, value)
        End Sub
        Private Sub Remove(ByVal value As Object) Implements IList.Remove
            TryCast(value, IList).Remove(value)
        End Sub
        Private Sub RemoveAt(ByVal index As Integer) Implements IList.RemoveAt
            TryCast(Value, IList).RemoveAt(index)
        End Sub
        Public Property IList_Item(ByVal index As Integer) As Object Implements IList.Item
            Get
                Return (TryCast(Value, IList))(index)
            End Get
            Set(ByVal value As Object)
                TryCast(value, IList)(index) = value
            End Set
        End Property
        Private ReadOnly Property Count() As Integer Implements ICollection.Count
            Get
                Return (TryCast(Value, IList)).Count
            End Get
        End Property
        Public Sub CopyTo(ByVal array As Array, ByVal index As Integer) Implements System.Collections.ICollection.CopyTo
            Value.CopyTo(array, index)
        End Sub
        Public ReadOnly Property SyncRoot() As Object Implements System.Collections.ICollection.SyncRoot
            Get
                Return (TryCast(Value, IList)).SyncRoot
            End Get
        End Property
        Public ReadOnly Property IsSynchronized() As Boolean Implements System.Collections.ICollection.IsSynchronized
            Get
                Return (TryCast(Value, IList)).IsSynchronized
            End Get
        End Property
    End Class
End Namespace

