'2008 IDesign Inc. 
'Questions? Comments? go to 
'http://www.idesign.net


Imports Microsoft.VisualBasic
Imports System
Imports System.Threading
Imports System.Collections
Imports System.Collections.Generic
Imports System.Transactions
Imports System.Diagnostics

Imports ServiceModelEx

Namespace ServiceModelEx.Transactional
   Public Class TransactionalDictionary(Of K, T)
	   Inherits TransactionalCollection(Of Dictionary(Of K,T),KeyValuePair(Of K,T))
	   Implements IDictionary(Of K,T)
	  Public Sub New()
		  Me.New(0)
	  End Sub
	  Public Sub New(ByVal dictionary As IDictionary(Of K,T))
		  MyBase.New(New Dictionary(Of K,T)(dictionary))
	  End Sub
	  Public Sub New(ByVal capacity As Integer)
		  MyBase.New(New Dictionary(Of K,T)(capacity))
	  End Sub
        Public ReadOnly Property Count() As Integer Implements IDictionary(Of K, T).Count
            Get
                Return Value.Count
            End Get
        End Property
        Public Function ContainsKey(ByVal key As K) As Boolean Implements IDictionary(Of K, T).ContainsKey
            Return Value.ContainsKey(key)
        End Function
        Public ReadOnly Property Keys() As ICollection(Of K) Implements IDictionary(Of K, T).Keys
            Get
                Return Value.Keys
            End Get
        End Property
        Public ReadOnly Property Values() As ICollection(Of T) Implements IDictionary(Of K, T).Values
            Get
                Return Value.Values
            End Get
        End Property
        Public Sub Clear() Implements IDictionary(Of K, T).Clear
            Value.Clear()
        End Sub
        Private Sub Add(ByVal item As KeyValuePair(Of K, T)) Implements IDictionary(Of K, T).Add
            TryCast(Value, ICollection(Of KeyValuePair(Of K, T))).Add(item)
        End Sub
        Default Public Property Item(ByVal key As K) As T Implements IDictionary(Of K, T).Item
            Get
                Return Value(key)
            End Get
            Set(ByVal value As T)
                MyBase.Value(key) = value
            End Set
        End Property
        Public Sub Add(ByVal key As K, ByVal item As T) Implements IDictionary(Of K, T).Add
            Value.Add(key, item)
        End Sub
        Public Function ContainsValue(ByVal item As T) As Boolean
            Return Value.ContainsValue(item)
        End Function
        Public Function TryGetValue(ByVal key As K, <System.Runtime.InteropServices.Out()> ByRef value As T) As Boolean Implements IDictionary(Of K, T).TryGetValue
            Return MyBase.Value.TryGetValue(key, value)
        End Function
        Public Function Remove(ByVal key As K) As Boolean Implements IDictionary(Of K, T).Remove
            Return Value.Remove(key)
        End Function
	  Private Function Contains(ByVal item As KeyValuePair(Of K,T)) As Boolean Implements ICollection(Of KeyValuePair(Of K,T)).Contains
		 Return (TryCast(Value, ICollection(Of KeyValuePair(Of K,T)))).Contains(item)
	  End Function
	  Private Sub CopyTo(ByVal array() As KeyValuePair(Of K,T), ByVal arrayIndex As Integer) Implements ICollection(Of KeyValuePair(Of K,T)).CopyTo
		 TryCast(Value, ICollection(Of KeyValuePair(Of K,T))).CopyTo(array,arrayIndex)
	  End Sub
	  Private Function ICollection_Remove(ByVal item As KeyValuePair(Of K,T)) As Boolean Implements ICollection(Of KeyValuePair(Of K,T)).Remove
		 Return (TryCast(Value, ICollection(Of KeyValuePair(Of K,T)))).Remove(item)
	  End Function
	  Private ReadOnly Property IsReadOnly() As Boolean Implements ICollection(Of KeyValuePair(Of K,T)).IsReadOnly
		 Get
			Return (TryCast(Value, ICollection(Of KeyValuePair(Of K,T)))).IsReadOnly
		 End Get
	  End Property
        Private Function GetEnumerator() As Dictionary(Of K, T).Enumerator
            Return Value.GetEnumerator()
        End Function
	  Public ReadOnly Property Comparer() As IEqualityComparer(Of K)
		 Get
			Return Value.Comparer
		 End Get
	  End Property
   End Class
End Namespace

