'2008 IDesign Inc. 
'Questions? Comments? go to 
'http://www.idesign.net


Imports Microsoft.VisualBasic
Imports System
Imports System.Threading
Imports System.Collections
Imports System.Collections.Generic
Imports System.Transactions
Imports System.Diagnostics

Imports ServiceModelEx

Namespace ServiceModelEx.Transactional
   Public Class TransactionalLinkedList(Of T)
	   Inherits TransactionalCollection(Of LinkedList(Of T),T)
	   Implements ICollection(Of T), IEnumerable(Of T), ICollection
	  Public Sub New(ByVal collection As IEnumerable(Of T))
		  MyBase.New(New LinkedList(Of T)(collection))
	  End Sub
	  Public ReadOnly Property Count() As Integer Implements ICollection(Of T).Count, ICollection.Count
		 Get
			Return Value.Count
		 End Get
	  End Property
	  Private Sub Add(ByVal item As T) Implements ICollection(Of T).Add
		 TryCast(Value, ICollection(Of T)).Add(item)
	  End Sub
	  Public Sub Clear() Implements ICollection(Of T).Clear
		 Value.Clear()
	  End Sub
	  Public Function Contains(ByVal item As T) As Boolean Implements ICollection(Of T).Contains
		 Return Value.Contains(item)
	  End Function
	  Public Function Remove(ByVal item As T) As Boolean Implements ICollection(Of T).Remove
		 Return Value.Remove(item)
	  End Function
	  Public Sub CopyTo(ByVal array() As T, ByVal arrayIndex As Integer) Implements ICollection(Of T).CopyTo
		 Value.CopyTo(array,arrayIndex)
	  End Sub
	  Private ReadOnly Property IsReadOnly() As Boolean Implements ICollection(Of T).IsReadOnly
		 Get
			Return (TryCast(Value, ICollection(Of T))).IsReadOnly
		 End Get
	  End Property
	  Private Sub ICollection_CopyTo(ByVal array As Array, ByVal arrayIndex As Integer) Implements ICollection.CopyTo
		 TryCast(Value, ICollection).CopyTo(array,arrayIndex)
	  End Sub
	  Public ReadOnly Property IsSynchronized() As Boolean Implements ICollection.IsSynchronized
		 Get
			Return False
		 End Get
	  End Property
	  Public ReadOnly Property SyncRoot() As Object Implements ICollection.SyncRoot
		 Get
			Return Me
		 End Get
	  End Property
	  Public Function AddAfter(ByVal node As LinkedListNode(Of T), ByVal value As T) As LinkedListNode(Of T)
            Return MyBase.Value.AddAfter(node, value)
	  End Function
	  Public Function AddBefore(ByVal node As LinkedListNode(Of T), ByVal value As T) As LinkedListNode(Of T)
            Return MyBase.Value.AddBefore(node, value)
	  End Function
	  Public Sub AddFirst(ByVal node As LinkedListNode(Of T))
		 Value.AddFirst(node)
	  End Sub
	  Public Function AddFirst(ByVal value As T) As LinkedListNode(Of T)
            Return MyBase.Value.AddFirst(value)
	  End Function
	  Public Function AddLast(ByVal value As T) As LinkedListNode(Of T)
            Return MyBase.Value.AddLast(value)
	  End Function
	  Public Sub AddLast(ByVal node As LinkedListNode(Of T))
		 Value.AddLast(node)
	  End Sub
	  Public Function Find(ByVal value As T) As LinkedListNode(Of T)
            Return MyBase.Value.Find(value)
	  End Function
	  Public Function FindLast(ByVal value As T) As LinkedListNode(Of T)
            Return MyBase.Value.FindLast(value)
	  End Function
	  Public Sub Remove(ByVal node As LinkedListNode(Of T))
		 Value.Remove(node)
	  End Sub
	  Public Sub RemoveFirst()
		 Value.RemoveFirst()
	  End Sub
	  Public Sub RemoveLast()
		 Value.RemoveLast()
	  End Sub
	  Public ReadOnly Property First() As LinkedListNode(Of T)
		 Get
			Return Value.First
		 End Get
	  End Property
	  Public ReadOnly Property Last() As LinkedListNode(Of T)
		 Get
			Return Value.Last
		 End Get
	  End Property
   End Class
End Namespace

