'2008 IDesign Inc. 
'Questions? Comments? go to 
'http://www.idesign.net


Imports Microsoft.VisualBasic
Imports System
Imports System.Threading
Imports System.Collections
Imports System.Collections.Generic
Imports System.Transactions
Imports System.Diagnostics

Imports ServiceModelEx
Imports System.Collections.ObjectModel

Namespace ServiceModelEx.Transactional
    Public Class TransactionalList(Of T)
        Inherits TransactionalCollection(Of List(Of T), T)
        Implements IList(Of T)
        Public Sub New()
            Me.New(0)
        End Sub
        Public Sub New(ByVal collection As IEnumerable(Of T))
            MyBase.New(New List(Of T)(collection))
        End Sub
        Public Sub New(ByVal capacity As Integer)
            MyBase.New(New List(Of T)(capacity))
        End Sub
        Public Property Capacity() As Integer
            Get
                Return Value.Capacity
            End Get
            Set(ByVal value As Integer)
                MyBase.Value.Capacity = value
            End Set
        End Property
        Public ReadOnly Property Count() As Integer Implements System.Collections.Generic.ICollection(Of T).Count
            Get
                Return Value.Count
            End Get
        End Property
        Public Function IndexOf(ByVal item As T) As Integer Implements IList(Of T).IndexOf
            Return Value.IndexOf(item)
        End Function

        Default Public Property Item(ByVal index As Integer) As T Implements IList(Of T).Item
            Get
                Return Value(index)
            End Get
            Set(ByVal value As T)
                MyBase.Value(index) = value
            End Set
        End Property
        Public Sub Add(ByVal item As T) Implements System.Collections.Generic.ICollection(Of T).Add
            Value.Add(item)
        End Sub
        Public Sub AddRange(ByVal collection As IEnumerable(Of T))
            Value.AddRange(collection)
        End Sub
        Public Sub Clear() Implements System.Collections.Generic.ICollection(Of T).Clear
            Value.Clear()
        End Sub
        Public Function ToArray() As T()
            Return Value.ToArray()
        End Function
        Public Function Contains(ByVal item As T) As Boolean Implements System.Collections.Generic.ICollection(Of T).Contains
            Return Value.Contains(item)
        End Function
        Public Sub Insert(ByVal index As Integer, ByVal item As T) Implements IList(Of T).Insert
            Value.Insert(index, item)
        End Sub
        Public Function Remove(ByVal item As T) As Boolean Implements System.Collections.Generic.ICollection(Of T).Remove
            Return Value.Remove(item)
        End Function
        Public Function RemoveAll(ByVal match As Predicate(Of T)) As Integer
            Return Value.RemoveAll(match)
        End Function
        Public Sub RemoveAt(ByVal index As Integer) Implements IList(Of T).RemoveAt
            Value.RemoveAt(index)
        End Sub
        Public Sub Reverse()
            Value.Reverse()
        End Sub
        Public Sub CopyTo(ByVal array() As T, ByVal arrayIndex As Integer) Implements System.Collections.Generic.ICollection(Of T).CopyTo
            Value.CopyTo(array, arrayIndex)
        End Sub
        Private ReadOnly Property IsReadOnly() As Boolean Implements ICollection(Of T).IsReadOnly
            Get
                Return (TryCast(Value, ICollection(Of T))).IsReadOnly
            End Get
        End Property
        Public Function AsReadOnly() As ReadOnlyCollection(Of T)
            Return Value.AsReadOnly()
        End Function
        Public Function BinarySearch(ByVal item As T) As Integer
            Return Value.BinarySearch(item)
        End Function
        Public Function BinarySearch(ByVal item As T, ByVal comparer As IComparer(Of T)) As Integer
            Return Value.BinarySearch(item, comparer)
        End Function
        Public Function BinarySearch(ByVal index As Integer, ByVal count As Integer, ByVal item As T, ByVal comparer As IComparer(Of T)) As Integer
            Return Value.BinarySearch(index, count, item, comparer)
        End Function
        Public Function ConvertAll(Of U)(ByVal converter As Converter(Of T, U)) As List(Of U)
            Return Value.ConvertAll(converter)
        End Function
        Public Sub CopyTo(ByVal index As Integer, ByVal array() As T, ByVal arrayIndex As Integer, ByVal count As Integer)
            Value.CopyTo(index, array, arrayIndex, count)
        End Sub
        Public Function Exists(ByVal match As Predicate(Of T)) As Boolean
            Return Value.Exists(match)
        End Function
        Public Function Find(ByVal match As Predicate(Of T)) As T
            Return Value.Find(match)
        End Function
        Public Function FindAll(ByVal match As Predicate(Of T)) As List(Of T)
            Return Value.FindAll(match)
        End Function
        Public Function FindIndex(ByVal match As Predicate(Of T)) As Integer
            Return Value.FindIndex(match)
        End Function
        Public Function FindIndex(ByVal startIndex As Integer, ByVal match As Predicate(Of T)) As Integer
            Return Value.FindIndex(startIndex, match)
        End Function
        Public Function FindIndex(ByVal startIndex As Integer, ByVal count As Integer, ByVal match As Predicate(Of T)) As Integer
            Return Value.FindIndex(startIndex, count, match)
        End Function
        Public Function FindLast(ByVal match As Predicate(Of T)) As T
            Return Value.FindLast(match)
        End Function
        Public Function FindLastIndex(ByVal match As Predicate(Of T)) As Integer
            Return Value.FindLastIndex(match)
        End Function
        Public Function FindLastIndex(ByVal startIndex As Integer, ByVal match As Predicate(Of T)) As Integer
            Return Value.FindLastIndex(startIndex, match)
        End Function
        Public Function FindLastIndex(ByVal startIndex As Integer, ByVal count As Integer, ByVal match As Predicate(Of T)) As Integer
            Return Value.FindLastIndex(startIndex, count, match)
        End Function
        Public Sub ForEach(ByVal action As Action(Of T))
            Value.ForEach(action)
        End Sub
        Public Function GetEnumerator() As List(Of T).Enumerator
            Return Value.GetEnumerator()
        End Function
        Public Function GetRange(ByVal index As Integer, ByVal count As Integer) As List(Of T)
            Return Value.GetRange(index, count)
        End Function
        Public Function IndexOf(ByVal item As T, ByVal index As Integer) As Integer
            Return Value.IndexOf(item, index)
        End Function
        Public Function IndexOf(ByVal item As T, ByVal index As Integer, ByVal count As Integer) As Integer
            Return Value.IndexOf(item, index, count)
        End Function
        Public Sub InsertRange(ByVal index As Integer, ByVal collection As IEnumerable(Of T))
            Value.InsertRange(index, collection)
        End Sub
        Public Function LastIndexOf(ByVal item As T) As Integer
            Return Value.LastIndexOf(item)
        End Function
        Public Function LastIndexOf(ByVal item As T, ByVal index As Integer) As Integer
            Return Value.LastIndexOf(item, index)
        End Function
        Public Function LastIndexOf(ByVal item As T, ByVal index As Integer, ByVal count As Integer) As Integer
            Return Value.LastIndexOf(item, index, count)
        End Function
        Public Sub RemoveRange(ByVal index As Integer, ByVal count As Integer)
            Value.RemoveRange(index, count)
        End Sub
        Public Sub Reverse(ByVal index As Integer, ByVal count As Integer)
            Value.Reverse(index, count)
        End Sub
        Public Sub Sort()
            Value.Sort()
        End Sub
        Public Sub Sort(ByVal comparer As IComparer(Of T))
            Value.Sort(comparer)
        End Sub
        Public Sub Sort(ByVal comparison As Comparison(Of T))
            Value.Sort(comparison)
        End Sub
        Public Sub Sort(ByVal index As Integer, ByVal count As Integer, ByVal comparer As IComparer(Of T))
            Value.Sort(index, count, comparer)
        End Sub
        Public Sub TrimExcess()
            Value.TrimExcess()
        End Sub
        Public Function TrueForAll(ByVal match As Predicate(Of T)) As Boolean
            Return Value.TrueForAll(match)
        End Function
    End Class
End Namespace
