'2008 IDesign Inc. 
'Questions? Comments? go to 
'http://www.idesign.net


Imports Microsoft.VisualBasic
Imports System
Imports System.Threading
Imports System.Collections
Imports System.Collections.Generic
Imports System.Transactions
Imports System.Diagnostics

Imports ServiceModelEx

Namespace ServiceModelEx.Transactional
    Public Class TransactionalSortedList(Of K, T)
        Inherits TransactionalCollection(Of SortedList(Of K, T), KeyValuePair(Of K, T))
        Implements IDictionary(Of K, T), IDictionary
        Public Sub New(ByVal dictionary As IDictionary(Of K, T))
            MyBase.New(New SortedList(Of K, T)(dictionary))
        End Sub
        Public Sub New(ByVal dictionary As IDictionary(Of K, T), ByVal comparer As IComparer(Of K))
            MyBase.New(New SortedList(Of K, T)(dictionary, comparer))
        End Sub
        Public Sub New(ByVal comparer As IComparer(Of K))
            MyBase.New(New SortedList(Of K, T)(comparer))
        End Sub
        Public Sub New(ByVal capacity As Integer)
            MyBase.New(New SortedList(Of K, T)(capacity))
        End Sub
        Public Sub New(ByVal capacity As Integer, ByVal comparer As IComparer(Of K))
            MyBase.New(New SortedList(Of K, T)(capacity, comparer))
        End Sub

        Public Function IndexOfKey(ByVal key As K) As Integer
            Return Value.IndexOfKey(key)
        End Function
        Public Function IndexOfValue(ByVal value As T) As Integer
            Return MyBase.Value.IndexOfValue(value)
        End Function
        Public Sub RemoveAt(ByVal index As Integer)
            Value.RemoveAt(index)
        End Sub
        Public Sub TrimExcess()
            Value.TrimExcess()
        End Sub
        Public Function TryGetValue(ByVal key As K, <System.Runtime.InteropServices.Out()> ByRef value As T) As Boolean Implements IDictionary(Of K, T).TryGetValue
            Return MyBase.Value.TryGetValue(key, value)
        End Function
        Public Property Capacity() As Integer
            Get
                Return Value.Capacity
            End Get
            Set(ByVal value As Integer)
                MyBase.Value.Capacity = value
            End Set
        End Property
        Public ReadOnly Property Count() As Integer Implements System.Collections.Generic.IDictionary(Of K, T).Count, System.Collections.ICollection.Count
            Get
                Return Value.Count
            End Get
        End Property
        Public ReadOnly Property Comparer() As IComparer(Of K)
            Get
                Return Value.Comparer
            End Get
        End Property
        Public Function ContainsKey(ByVal key As K) As Boolean Implements IDictionary(Of K, T).ContainsKey
            Return Value.ContainsKey(key)
        End Function
        Private ReadOnly Property IDictionary_KeysTyped() As ICollection(Of K) Implements IDictionary(Of K, T).Keys
            Get
                Return (TryCast(Value, IDictionary(Of K, T))).Keys
            End Get
        End Property
        Private ReadOnly Property IDictionary_ValuesTyped() As ICollection(Of T) Implements IDictionary(Of K, T).Values
            Get
                Return (TryCast(Value, IDictionary(Of K, T))).Values
            End Get
        End Property
        Public ReadOnly Property Keys() As IList(Of K)
            Get
                Return Value.Keys
            End Get
        End Property
        Public ReadOnly Property Values() As IList(Of T)
            Get
                Return Value.Values
            End Get
        End Property
        Private ReadOnly Property SyncRoot() As Object Implements ICollection.SyncRoot
            Get
                Return (TryCast(Value, ICollection)).SyncRoot
            End Get
        End Property
        Private ReadOnly Property IsSynchronized() As Boolean Implements ICollection.IsSynchronized
            Get
                Return (TryCast(Value, ICollection)).IsSynchronized
            End Get
        End Property
        Public Sub Clear() Implements IDictionary.Clear, IDictionary(Of K, T).Clear
            Value.Clear()
        End Sub
        Private Sub Add(ByVal item As KeyValuePair(Of K, T)) Implements ICollection(Of KeyValuePair(Of K, T)).Add
            TryCast(Value, ICollection(Of KeyValuePair(Of K, T))).Add(item)
        End Sub
        Default Public Property Item(ByVal key As K) As T Implements IDictionary(Of K, T).Item
            Get
                Return Value(key)
            End Get
            Set(ByVal value As T)
                MyBase.Value(key) = value
            End Set
        End Property
        Public Sub Add(ByVal key As K, ByVal item As T) Implements IDictionary(Of K, T).Add
            Value.Add(key, item)
        End Sub
        Public Function ContainsValue(ByVal item As T) As Boolean
            Return Value.ContainsValue(item)
        End Function
        Public Function Remove(ByVal key As K) As Boolean Implements IDictionary(Of K, T).Remove
            Return Value.Remove(key)
        End Function
        Private Sub IDictionary_Remove(ByVal key As Object) Implements IDictionary.Remove
            TryCast(Value, IDictionary(Of K, T)).Remove(CType(key, K))
        End Sub
        Private Function Contains(ByVal item As KeyValuePair(Of K, T)) As Boolean Implements ICollection(Of KeyValuePair(Of K, T)).Contains
            Return (TryCast(Value, ICollection(Of KeyValuePair(Of K, T)))).Contains(item)
        End Function
        Private Sub CopyTo(ByVal array() As KeyValuePair(Of K, T), ByVal arrayIndex As Integer) Implements ICollection(Of KeyValuePair(Of K, T)).CopyTo
            TryCast(Value, ICollection(Of KeyValuePair(Of K, T))).CopyTo(array, arrayIndex)
        End Sub
        Private Sub CopyTo(ByVal array As Array, ByVal arrayIndex As Integer) Implements ICollection.CopyTo
            TryCast(Value, ICollection).CopyTo(array, arrayIndex)
        End Sub
        Private Function ICollection_Remove(ByVal item As KeyValuePair(Of K, T)) As Boolean Implements ICollection(Of KeyValuePair(Of K, T)).Remove
            Return (TryCast(Value, ICollection(Of KeyValuePair(Of K, T)))).Remove(item)
        End Function
        Private ReadOnly Property IsReadOnly_ICollection() As Boolean Implements ICollection(Of KeyValuePair(Of K, T)).IsReadOnly
            Get
                Return (TryCast(Value, ICollection(Of KeyValuePair(Of K, T)))).IsReadOnly
            End Get
        End Property
        Private ReadOnly Property IsReadOnly_IDictionary() As Boolean Implements IDictionary.IsReadOnly
            Get
                Return (TryCast(Value, IDictionary)).IsReadOnly
            End Get
        End Property
        Private Sub IDictionary_Add(ByVal key As Object, ByVal value As Object) Implements IDictionary.Add
            TryCast(value, IDictionary(Of K, T)).Add(CType(key, K), CType(value, T))
        End Sub
        Private Function Contains(ByVal key As Object) As Boolean Implements IDictionary.Contains
            Return (TryCast(Value, IDictionary(Of K, T))).ContainsKey(CType(key, K))
        End Function

        Private ReadOnly Property IsFixedSize() As Boolean Implements IDictionary.IsFixedSize
            Get
                Return (TryCast(Value, IDictionary)).IsFixedSize
            End Get
        End Property
        Public Property IDictionary_Item(ByVal key As Object) As Object Implements IDictionary.Item
            Get
                Return (TryCast(Value, IDictionary))(CType(key, K))
            End Get
            Set(ByVal value As Object)
                TryCast(value, SortedDictionary(Of K, T))(CType(key, K)) = CType(value, T)
            End Set
        End Property
        Private ReadOnly Property IDictionary_Keys() As ICollection Implements IDictionary.Keys
            Get
                Return (TryCast(Value, IDictionary)).Keys
            End Get
        End Property
        Private ReadOnly Property IDictionary_Values() As ICollection Implements IDictionary.Values
            Get
                Return (TryCast(Value, IDictionary)).Values
            End Get
        End Property
        Private Function GetEnumerator() As IDictionaryEnumerator Implements IDictionary.GetEnumerator
            Return (TryCast(Value, IDictionary)).GetEnumerator()
        End Function
    End Class
End Namespace

