'2008 IDesign Inc. 
'Questions? Comments? go to 
'http://www.idesign.net


Imports Microsoft.VisualBasic
Imports System
Imports System.Threading
Imports System.Collections
Imports System.Collections.Generic
Imports System.Transactions
Imports System.Diagnostics

Imports ServiceModelEx

Namespace ServiceModelEx.Transactional
   Public Class TransactionalStack(Of T)
	   Inherits TransactionalCollection(Of Stack(Of T),T)
	   Implements ICollection
	  Public Sub New()
		  Me.New(0)
	  End Sub
	  Public Sub New(ByVal collection As IEnumerable(Of T))
		  MyBase.New(New Stack(Of T)(collection))
	  End Sub
	  Public Sub New(ByVal capacity As Integer)
		  MyBase.New(New Stack(Of T)(capacity))
	  End Sub
	  Public Sub Push(ByVal item As T)
		 Value.Push(item)
	  End Sub
	  Public Function Pop() As T
		 Return Value.Pop()
	  End Function
	  Public Sub Clear()
		 Value.Clear()
	  End Sub
	  Public Function Contains(ByVal item As T) As Boolean
		Return Value.Contains(item)
	  End Function
	  Public ReadOnly Property Count() As Integer Implements ICollection.Count
		 Get
			Return Value.Count
		 End Get
	  End Property
	  Public Function Peek() As T
		 Return Value.Peek()
	  End Function
	  Public Function ToArray() As T()
		 Return Value.ToArray()
	  End Function
	  Public Sub TrimExcess()
		 Value.TrimExcess()
	  End Sub
	  Private Sub ICollection_CopyTo(ByVal array As Array, ByVal arrayIndex As Integer) Implements ICollection.CopyTo
		 TryCast(Value, ICollection).CopyTo(array,arrayIndex)
	  End Sub
	  Private Sub CopyTo(ByVal array() As T, ByVal arrayIndex As Integer)
		 Value.CopyTo(array,arrayIndex)
	  End Sub
	  Public ReadOnly Property IsSynchronized() As Boolean Implements ICollection.IsSynchronized
		 Get
			Return False
		 End Get
	  End Property
	  Public ReadOnly Property SyncRoot() As Object Implements ICollection.SyncRoot
		 Get
			Return Me
		 End Get
	  End Property
        Public Function GetEnumerator() As Stack(Of T).Enumerator
            Return MyBase.Value.GetEnumerator()
        End Function

   End Class
End Namespace

